<?php

use Drupal\views\EntityViewsData;

/**
 * Implements hook_views_data().
 */
function idealyzer_views_data() {
  $data = [];

  // Table definition for the custom entity.
  $data['site_scanner_result']['table'] = [
    'group' => t('Site Scanner Results'),
    'base' => [
      'field' => 'id',
      'title' => t('Site Scanner Result'),
      'help' => t('The Site Scanner Result entity ID.'),
    ],
  ];

  // Define each field to expose to Views.
  $fields = [
    'id' => t('ID'),
    'scan_data' => t('Scan Data'),
    'scan_date' => t('Scan Date'),
    'target_url_domain' => t('Target URL Domain'),
    'final_url' => t('Final URL'),
    'final_url_status_code' => t('Final URL Status Code'),
    'final_url_live' => t('Final URL Live'),
    // Add other fields as needed.
  ];

  foreach ($fields as $field_name => $field_label) {
    $data['site_scanner_result'][$field_name] = [
      'title' => $field_label,
      'help' => t('The @field_name field of the Site Scanner Result entity.', ['@field_name' => $field_label]),
      'field' => [
        'id' => 'standard',
      ],
      'sort' => [
        'id' => 'standard',
      ],
      'filter' => [
        'id' => 'standard',
      ],
    ];
  }

  return $data;
}
