<?php

namespace Drupal\idealyzer\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\views\Views;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\Response;
use Drupal\idealyzer\Service\SiteScannerService;
/**
 * Class SiteScannerResultViewController.
 */
class SiteScannerResultViewController extends ControllerBase {

  /**
   * The Views executable object.
   *
   * @var \Drupal\views\ViewExecutable
   */
  protected $view;

  /**
   * SiteScannerResultViewController constructor.
   *
   * @param \Drupal\views\ViewExecutable $view
   *   The Views executable object.
   */
  public function __construct($view) {
    $this->view = $view;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    $view = Views::getView('site_scanner_results');
    if (!$view) {
      \Drupal::logger('idealyzer')->error('Failed to load view: site_scanner_results');
    } else {
      \Drupal::logger('idealyzer')->info('Successfully loaded view: site_scanner_results');
    }
    return new static($view);
  }

  /**
   * Display the view.
   *
   * @return array
   *   The render array.
   */
  public function listing() {
    if ($this->view) {
      \Drupal::logger('idealyzer')->info('Successfully loaded view: site_scanner_results in listing method');
      $this->view->setDisplay('page_1');
      $this->view->preExecute();
      $this->view->execute();
      return $this->view->render();
    }
    else {
      \Drupal::logger('idealyzer')->error('View is not loaded correctly.');
      return [
        '#markup' => $this->t('View could not be loaded.'),
      ];
    }
  }
}
