<?php

namespace Drupal\idealyzer\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Form controller for Site Scanner Result edit forms.
 */
class SiteScannerResultForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    /* @var $entity \Drupal\idealyzer\Entity\SiteScannerResult */
    $form = parent::buildForm($form, $form_state);

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    $entity = $this->entity;
    $status = $entity->save();

    switch ($status) {
      case SAVED_NEW:
        drupal_set_message($this->t('Created the %label Site Scanner Result.', [
          '%label' => $entity->label(),
        ]));
        break;

      default:
        drupal_set_message($this->t('Saved the %label Site Scanner Result.', [
          '%label' => $entity->label(),
        ]));
    }

    $form_state->setRedirect('entity.site_scanner_result.canonical', ['site_scanner_result' => $entity->id()]);
  }

}
