<?php

namespace Drupal\idealyzer;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityAccessControlHandler;
use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;

/**
 * Access controller for the Site Scanner Result entity.
 *
 * @see \Drupal\idealyzer\Entity\SiteScannerResult.
 */
class SiteScannerResultAccessControlHandler extends EntityAccessControlHandler {

  /**
   * {@inheritdoc}
   */
  protected function checkAccess(EntityInterface $entity, $operation, AccountInterface $account) {
    /** @var \Drupal\idealyzer\Entity\SiteScannerResultInterface $entity */
    switch ($operation) {
      case 'view':
        return AccessResult::allowedIfHasPermission($account, 'view site scanner results');

      case 'update':
        return AccessResult::allowedIfHasPermission($account, 'administer site scanner results');

      case 'delete':
        return AccessResult::allowedIfHasPermission($account, 'administer site scanner results');
    }

    return AccessResult::neutral();
  }

  /**
   * {@inheritdoc}
   */
  protected function checkCreateAccess(AccountInterface $account, array $context, $entity_bundle = null) {
    return AccessResult::allowedIfHasPermission($account, 'administer site scanner results');
  }

}
